Bug 829676 - Review Request: pyelftools - Pure-Python library for parsing and analyzing ELF files
Review Request: pyelftools - Pure-Python library for parsing and analyzing EL...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Björn 'besser82' Esser
Fedora Extras Quality Assurance
:
Depends On: 972364
Blocks:
  Show dependency treegraph
 
Reported: 2012-06-07 05:27 EDT by kushaldas@gmail.com
Modified: 2013-08-31 19:56 EDT (History)
9 users (show)

See Also:
Fixed In Version: pyelftools-0.22-0.1.git20130619.a1d9681.fc18
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-08-18 17:35:04 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
besser82: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description kushaldas@gmail.com 2012-06-07 05:27:47 EDT
Spec URL: http://kushal.fedorapeople.org/packages/pyelftools.spec
SRPM URL: http://kushal.fedorapeople.org/packages/pyelftools-0.20-1.fc17.src.rpm
Description: Pure-Python library for parsing and analyzing ELF files
Fedora Account System Username: kushal
Comment 1 Michel Alexandre Salim 2012-06-07 06:27:31 EDT
Taking this review
Comment 2 Michel Alexandre Salim 2012-06-07 14:09:40 EDT
two EPEL5-only spec features need to be removed (%defattr and cleaning the buildroot at the beginning of %install) -- and there are test cases in test/ that mostly pass, you'd probably want to at least run the first two and inform upstream about the third.

Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



==== Generic ====
[x]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[x]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Buildroot is not present
     Note: Unless packager wants to package for EPEL5 this is fine
[x]: MUST Package contains no bundled libraries.
[x]: MUST Changelog in prescribed format.
[x]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean would be needed if support for EPEL is required
[x]: MUST Sources contain only permissible code or content.
[!]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: defattr(....) present in %files section. This is OK if packaging
     for EPEL5. Otherwise not needed
[x]: MUST Macros in Summary, %description expandable at SRPM build time.
[x]: MUST Package requires other packages for directories it uses.
[x]: MUST Package uses nothing in %doc for runtime.
[x]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[!]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf is only needed if supporting EPEL5
[-]: MUST Large documentation files are in a -doc subpackage, if required.
[x]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[x]: MUST License field in the package spec file matches the actual license.
[x]: MUST Package consistently uses macros (instead of hard-coded directory
     names).
[x]: MUST Package is named according to the Package Naming Guidelines.
[x]: MUST Package does not generate any conflict.
[x]: MUST Package obeys FHS, except libexecdir and /usr/target.
[x]: MUST Package must own all directories that it creates.
[x]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[x]: MUST Requires correct, justified where necessary.
[x]: MUST Rpmlint output is silent.
[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
/home/michel/sources/fedora/projects/FedoraReview/src/829676/pyelftools-0.20.tar.gz :
  MD5SUM this package     : 5ac7b279a01c41e5b022a1a382eb9d92
  MD5SUM upstream package : 5ac7b279a01c41e5b022a1a382eb9d92

[x]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: MUST Package contains a SysV-style init script if in need of one.
[x]: MUST File names are valid UTF-8.
[-]: MUST Useful -debuginfo package or justification otherwise.
[x]: SHOULD Reviewer should test that the package builds in mock.
[-]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[x]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: SHOULD Package functions as described.
[x]: SHOULD Latest version is packaged.
[x]: SHOULD Package does not include license text files separate from
     upstream.
[x]: SHOULD SourceX is a working URL.
[-]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[!]: SHOULD %check is present and all tests pass.
     The three scripts in test/ should be run (from the main source
     directory).  Note that run_readelf_tests currently fails but it
     looks like a simple matter of aligning the expected and actual
     result -- absolute vs relative paths -- might be worth asking
     upstream about though
[x]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.

Issues:
[!]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: defattr(....) present in %files section. This is OK if packaging
     for EPEL5. Otherwise not needed
See: http://fedoraproject.org/wiki/Packaging/Guidelines#FilePermissions
[!]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf is only needed if supporting EPEL5
See: None
[!]: SHOULD %check is present and all tests pass.
     The three scripts in test/ should be run (from the main source
     directory).  Note that run_readelf_tests currently fails but it
     looks like a simple matter of aligning the expected and actual
     result -- absolute vs relative paths -- might be worth asking
     upstream about though


Generated by fedora-review 0.2.0git
External plugins:
Comment 3 Michel Alexandre Salim 2012-09-02 00:47:59 EDT
Ping - Kushal?
Comment 4 Soumya Kanti Chakraborty 2012-09-05 14:51:17 EDT
(In reply to comment #3)
> Ping - Kushal?

Michel, Kushal is ill (high fever) and Hospitalised. He is bit better and will answer upon your query as soon as he gets online.
Comment 5 Terje Røsten 2013-05-09 07:42:49 EDT
I hope Kushal is getting better, in his absent I have updated the package:

spec: http://terjeros.fedorapeople.org/pyelftools/pyelftools.spec
srpm: http://terjeros.fedorapeople.org/pyelftools/pyelftools-0.21-1.fc18.src.rpm
koji: http://koji.fedoraproject.org/koji/taskinfo?taskID=5353180


Note: run_readelf_tests.py fails in koji rawhide, however works on local system.
Comment 6 Alec Leamas 2013-06-08 00:28:10 EDT
To me, looks like bundling the construct library: http://construct.readthedocs.org/en/latest/
Comment 7 Björn 'besser82' Esser 2013-06-08 03:57:28 EDT
Hello Michel!

Is it OK to you, if'll take over the review for this?

Cheers,
  Björn
Comment 8 Terje Røsten 2013-06-08 18:10:32 EDT
Updated package:

- Remove bundled construct lib

spec: http://terjeros.fedorapeople.org/pyelftools/pyelftools.spec
srpm: http://terjeros.fedorapeople.org/pyelftools/pyelftools-0.21-2.fc18.src.rpm
Comment 9 Björn 'besser82' Esser 2013-06-09 02:52:44 EDT
Seems to be fine, but (possibly) the issue during %check.

Someone who is more in touch with ELF-structures should look a the inline-diff, I put into the review-result, and comment about. I think it's just an issue with alignment of output, but don't want to judge this myself alone...

#####

Package Review
==============

Legend:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package complies to the Packaging Guidelines
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated", "*No copyright* Public domain". 1 files have
     unknown license. Detailed output of licensecheck in
     /home/bjoern.esser/fedora/review/829676-pyelftools/licensecheck.txt
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 10240 bytes in 2 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

Python:
[x]: Python eggs must not download any dependencies during the build process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.

     ---> last test fail on diffing the results.
          seems to be caused by some misalignment.
          nothing to worry, I think...

	  --- out1_CyTVCG.stdout	2013-06-09 08:30:08.121785966 +0200
	  +++ out2_DwKS_P.stdout	2013-06-09 08:30:08.121785966 +0200
	  @@ -6,7 +6,7 @@
	        Abbrev Offset: 0x0
	        Pointer Size:  8
	      <0><b>: Abbrev Number: 1 (DW_TAG_compile_unit)
	  -    <c>   DW_AT_producer    : clang version 3.0 (trunk 136555)	
	  +    < c>   DW_AT_producer    : clang version 3.0 (trunk 136555)	
	       <2d>   DW_AT_language    : 4	(C++)
	       <2f>   DW_AT_name        : penalty.cpp	
	       <3b>   DW_AT_entry_pc    : 0x0	
	  @@ -25,12 +25,14 @@
	  <2><75>: Abbrev Number: 5 (DW_TAG_subrange_type)
	       <76>   DW_AT_type        : <0x69>	
	       <7a>   DW_AT_upper_bound : 255	
	  + <2><7c>: Abbrev Number: 0
	    <1><7d>: Abbrev Number: 4 (DW_TAG_array_type)
	       <7e>   DW_AT_sibling     : <0x8d>	
	       <82>   DW_AT_type        : <0x61>	
	    <2><86>: Abbrev Number: 6 (DW_TAG_subrange_type)
	       <87>   DW_AT_type        : <0x69>	
	       <8b>   DW_AT_upper_bound : 2	
	  + <2><8c>: Abbrev Number: 0
	    <1><8d>: Abbrev Number: 2 (DW_TAG_base_type)
	       <8e>   DW_AT_encoding    : 5	(signed)
	       <8f>   DW_AT_name        : int	
	  @@ -337,6 +339,8 @@
	    <3><3e5>: Abbrev Number: 11 (DW_TAG_formal_parameter)
	       <3e6>   DW_AT_type        : <0xa6>	
	       <3ea>   DW_AT_artificial  : 1	
	  + <3><3eb>: Abbrev Number: 0
	  + <2><3ec>: Abbrev Number: 0
	    <1><3ed>: Abbrev Number: 4 (DW_TAG_array_type)
	       <3ee>   DW_AT_sibling     : <0x403>	
	       <3f2>   DW_AT_type        : <0xac>	
	  @@ -346,6 +350,7 @@
	    <2><3fc>: Abbrev Number: 6 (DW_TAG_subrange_type)
	       <3fd>   DW_AT_type        : <0x69>	
	       <401>   DW_AT_upper_bound : 10	
	  + <2><402>: Abbrev Number: 0
	    <1><403>: Abbrev Number: 12 (DW_TAG_variable)
	       <404>   DW_AT_name        : PenaltyTaker	
	       <411>   DW_AT_type        : <0x3ed>	
	  @@ -359,6 +364,7 @@
	    <2><42b>: Abbrev Number: 6 (DW_TAG_subrange_type)
	       <42c>   DW_AT_type        : <0x69>	
	       <430>   DW_AT_upper_bound : 1	
	  + <2><431>: Abbrev Number: 0
	    <1><432>: Abbrev Number: 12 (DW_TAG_variable)
	       <433>   DW_AT_name        : KickTakers	
	       <43e>   DW_AT_type        : <0x422>	
	  @@ -408,6 +414,9 @@
	       <506>   DW_AT_decl_line   : 63	
	       <507>   DW_AT_type        : <0x8d>	
	       <50b>   DW_AT_location    : 2 byte block: 91 5c 	(DW_OP_fbreg: -36)
	  + <4><50e>: Abbrev Number: 0
	  + <3><50f>: Abbrev Number: 0
	  + <2><510>: Abbrev Number: 0
	    <1><511>: Abbrev Number: 16 (DW_TAG_subprogram)
	       <512>   DW_AT_MIPS_linkage_name: _Z8GoalDiffv	
	       <51f>   DW_AT_name        : GoalDiff	
	  @@ -464,6 +473,8 @@
	       <5e5>   DW_AT_decl_line   : 114	
	       <5e6>   DW_AT_type        : <0x8d>	
	       <5ea>   DW_AT_location    : 2 byte block: 91 6c 	(DW_OP_fbreg: -20)
	  + <3><5ed>: Abbrev Number: 0
	  + <2><5ee>: Abbrev Number: 0
	    <1><5ef>: Abbrev Number: 17 (DW_TAG_subprogram)
	       <5f0>   DW_AT_MIPS_linkage_name: _Z11TakePenaltyii	
	       <602>   DW_AT_name        : TakePenalty	
	  @@ -498,4 +509,8 @@
	       <672>   DW_AT_decl_line   : 173	
	       <673>   DW_AT_type        : <0x8d>	
	       <677>   DW_AT_location    : 2 byte block: 91 54 	(DW_OP_fbreg: -44)
	  + <4><67a>: Abbrev Number: 0
	  + <3><67b>: Abbrev Number: 0
	  + <2><67c>: Abbrev Number: 0
	  + <1><67d>: Abbrev Number: 0

[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: pyelftools-0.21-2.fc20.noarch.rpm
pyelftools.noarch: W: no-manual-page-for-binary pyreadelf
1 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint pyelftools
pyelftools.noarch: W: no-manual-page-for-binary pyreadelf
1 packages and 0 specfiles checked; 0 errors, 1 warnings.
# echo 'rpmlint-done:'

---> You might want to add a manpage or ask upstream to do so...


Requires
--------
pyelftools (rpmlib, GLIBC filtered):
    /usr/bin/python
    python(abi)
    python-construct



Provides
--------
pyelftools:
    pyelftools



Source checksums
----------------
https://pypi.python.org/packages/source/p/pyelftools/pyelftools-0.21.tar.gz :
  CHECKSUM(SHA256) this package     : a9a10d894c698ab3a2d909c3df1c3d88d0ab03811351c278b3f520204f33d834
  CHECKSUM(SHA256) upstream package : a9a10d894c698ab3a2d909c3df1c3d88d0ab03811351c278b3f520204f33d834


Generated by fedora-review 0.4.1 (b2e211f) last change: 2013-04-29
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 829676
Comment 10 Paul Wouters 2013-06-10 10:17:29 EDT
paul@thinkpad:~$ rpmbuild -ba rpmbuild/SPECS/pyelftools.spec 
error: Failed build dependencies:
	python-construct is needed by pyelftools-0.21-2.fc18.noarch

paul@thinkpad:~$ yum search python-construct
Warning: No matches found for: python-construct
Comment 11 Terje Røsten 2013-06-10 10:21:24 EDT
Please have a look at the "Depends On" tag on this very page :-)
Comment 12 Björn 'besser82' Esser 2013-06-10 10:23:02 EDT
(In reply to Paul Wouters from comment #10)
> paul@thinkpad:~$ rpmbuild -ba rpmbuild/SPECS/pyelftools.spec 
> error: Failed build dependencies:
> 	python-construct is needed by pyelftools-0.21-2.fc18.noarch
> 
> paul@thinkpad:~$ yum search python-construct
> Warning: No matches found for: python-construct

see bz 972364
I approved it yesterday, just needs to be pushed by packger...
Comment 13 Björn 'besser82' Esser 2013-06-10 10:25:52 EDT
Still needinfo see my comment #9
Comment 14 Terje Røsten 2013-06-10 17:20:44 EDT
Updated to latest git, is this better Björn?

srpm: http://terjeros.fedorapeople.org/pyelftools/pyelftools-0.22-2.fc19.src.rpm
Comment 15 Björn 'besser82' Esser 2013-06-11 10:40:41 EDT
Unfortunately the second test is still failing, but after some research it's _REALLY_ caused by some misalignment in output of pyelftools (or more precisely it's testsuite using some grep-magic will fix) and readelf.

So with this information I can say, safely:

APPROVED!
Comment 16 Björn 'besser82' Esser 2013-07-27 14:49:07 EDT
No interest in bringing this into SCM?  Kushal, Terje?  If there won't be any response on this until 2013-08-12, I'll file an SCM request on this.
Comment 17 Björn 'besser82' Esser 2013-08-15 03:21:28 EDT
(In reply to Björn Esser from comment #16)
> No interest in bringing this into SCM?  Kushal, Terje?  If there won't be
> any response on this until 2013-08-12, I'll file an SCM request on this.

As "promised" and and both requestees are not interessted bringing this into SCM after granted review, I'm filing the SCM-request myself now requesting co-maintainer perms for you as well.

#####

New Package SCM Request
=======================
Package Name: pyelftools
Short Description: Pure-Python library for parsing and analyzing ELF files
Owners: besser82 kushal terjeros
Branches: el6 f18 f19
InitialCC:
Comment 18 Gwyn Ciesla 2013-08-15 08:17:48 EDT
Git done (by process-git-requests).
Comment 19 Paul Wouters 2013-08-16 14:25:01 EDT
I'm a little confused about upstream. It seems to have changed to https://github.com/eliben/pyelftools/ but there is no version 0.22, only 0.21?
Comment 20 Björn 'besser82' Esser 2013-08-16 14:38:23 EDT
There had been a 0.22 somewhen around June, but upstream revoked it.  I'll fix this on import creating a recent git snapshot tarball.  Will be something like 0.22-0.1.git%{commitdate}.%{shortcommit} then.

Objections?
Comment 21 Paul Wouters 2013-08-16 15:36:25 EDT
That's fine. Thanks.
Comment 22 Fedora Update System 2013-08-17 07:05:36 EDT
pyelftools-0.22-0.1.git20130619.a1d9681.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/pyelftools-0.22-0.1.git20130619.a1d9681.fc18
Comment 23 Fedora Update System 2013-08-17 07:06:27 EDT
pyelftools-0.22-0.1.git20130619.a1d9681.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/pyelftools-0.22-0.1.git20130619.a1d9681.fc19
Comment 24 Fedora Update System 2013-08-17 20:34:08 EDT
pyelftools-0.22-0.1.git20130619.a1d9681.fc19 has been pushed to the Fedora 19 testing repository.
Comment 25 Fedora Update System 2013-08-18 17:35:04 EDT
pyelftools-0.22-0.1.git20130619.a1d9681.fc19 has been pushed to the Fedora 19 stable repository.
Comment 26 Fedora Update System 2013-08-31 19:56:54 EDT
pyelftools-0.22-0.1.git20130619.a1d9681.fc18 has been pushed to the Fedora 18 stable repository.

Note You need to log in before you can comment on or make changes to this bug.